#include "testApp.h"

//For Some reason this doesn't work inside the testApp class in testApp.h
//So we put it here

CrtRender   _CrtRender; 

/* Some notes */
// -Almost everything is ripped from the viewer example project - so nice that they bundle an xcode project!
// -To see their full demo app - look at colladaDome/mainPC.cpp 
// -I needed to download the Cg framework from Nvidia ( its now bundled - so you shouldn't need to grab it )
// -I was getting bad crashes from CrtPrint which was being called internally - there was a note that CrtPrint would crash if passed arguments flags %s %i etc
// so I commented out the inside of CrtPrint and it ran fine.
// -To load a file drag it and all its resources to the sidebar of your project and then drag
// those files (once in the sidebar) down to the last Copy Files build phase inside of Targets->YourAppName->Copy File

/* To do */ 
// -Get files loading out of the data folder - tricky because .dae files reference other files.
// -Universal libs for everything ( uggg ) 
// -Make awesome projects!!

//--------------------------------------------------------------
CrtInt32 InitGL(GLvoid){
	
	glEnable(GL_TEXTURE_2D);						
	glShadeModel(GL_SMOOTH);						
	glClearColor(0.9f, 0.9f, 0.9f, 1.0f);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);							
	glDepthFunc(GL_LEQUAL);								
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	

	glEnable(GL_LIGHT0);								
	glEnable(GL_LIGHTING);

    glEnable( GL_CULL_FACE );
    glCullFace( GL_BACK ); 

	return true;										
}

//--------------------------------------------------------------
void testApp::setup(){

	ofBackground(100, 100, 100);

	// Set the default screen size
	_CrtRender.SetScreenWidth(ofGetWidth());
	_CrtRender.SetScreenHeight(ofGetHeight());

	// Initialize the renderer
	// !!!GAC for compatibility with the new COLLADA_FX code, Init now forces UsingCg and UsingVBOs to
	// !!!GAC false.  It also calls CrtInitCg, creating the CG context and calling cgGLRegisterStates.
	// !!!GAC All these things are currently required for the cfx rendering path to work, changing them
	// !!!GAC may cause problems.  This is work in progress and will be much cleaner when the refactor is done.
	_CrtRender.Init();

	// !!!GAC kept for reference, changing these may cause problems with the cfx include path
	//_CrtRender.SetUsingCg( CrtFalse ); //( theo this was commented out by them ) 
	_CrtRender.SetUsingVBOs( CrtTrue ); 
	_CrtRender.SetUsingNormalMaps( CrtTrue ); 	

	printf("loading collada model\n");
	
	//You can also load this model too: seymourplane.dae !!
	if ( !_CrtRender.Load( "astroBoy_walk.dae" )){
	
		printf("unable to load model!\n");
		printf("model and all its resources should be added to the sidebar of your project and\nthen dragged down to the last Copy Files build phase inside of Targets->YourAppName->Copy File\n");
		
	}

	InitGL();

}

//--------------------------------------------------------------
void testApp::update(){

}

//--------------------------------------------------------------
void testApp::draw(){
	
	ofSetColor(0, 0, 0); //doesn't come out black because we have lights on!
	ofDrawBitmapString("keys 1-4 to load files", 10, 20);

	_CrtRender.SetScreenWidth(ofGetWidth());
	_CrtRender.SetScreenHeight(ofGetHeight());		
		
	//Flip OF for OpenGL friendly mode.
	ofTranslate(0, ofGetHeight(), 0);
	ofScale(1, -1, 1);
	
	if(_CrtRender.GetScene()) _CrtRender.Render(); 

}

//--------------------------------------------------------------
void testApp::keyPressed(int key){
	if( key == '1'){
		_CrtRender.Load( "astroBoy_walk.dae" );
	}
	if( key == '2'){
		_CrtRender.Load( "seymourplane.dae" );
	}
	if( key == '3'){
		_CrtRender.Load( "dominos.dae" );
	}	
	if( key == '4'){
		_CrtRender.Load( "morph.dae" );
	}			
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
	if( ofGetFrameNum() > 5 ){
		_CrtRender.ActiveInstanceCamera->SetPanAndTilt( (lastX-(float)x) * 0.5 , (lastY-(float)y) * 0.5 );
	}
	
	lastX = x;
	lastY = y;
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

